Subject: Re: bug#5080: indic text is not displayed correctly in emacs shell

From: Kenichi Handa <[email-masked]>
Date: Fri, 04 Dec 2009 11:16:29 +0900

In article <[email-masked]>, Praveen A <[email-masked]> writes:

> > (set-fontset-font t 'malayalam '("rachana" . "unicode-bmp"))
> >
> > I installed rachana font and confirmed that the above code
> > worked.

> Thanks. It works for me now. But how to make it default?

Please put that in your .emacs.

> I have my fontconfig preferences to prefer Meera, but emacs does not
> respect that and takes Lohit Malayalam instead.

Currently Emacs just uses the first font found to support
Malayalam.  What is returned when you do this?
% fc-list :lang=ml

For fontconfig, we should modify the function ftfont_list in
(src/ftfont.c) to respect user configuration, but currently
I don't have a time to do that.

> (4a) Why is it taking Lohit Malayalam by default
> (4b) Why is the display cluttered/overlapped with some fonts like Meera

> (1a) now with your patch, emacs handles ZWJ
> (1b) There is a problem with Lohit Malayalam, I had a discussion with
> Lohit developer (Pravin Satpute) and he says it is an issue with
> m17n/redering engine.

> Meera and Rachana uses substitution for complex glyphs, but Lohit uses
> some fatures of OpenType specification and which needs to be
> implemented in rendering engine used by emacs.

For a rendering problem with a specific font, please send a
set of the following info separately for each problem.  You
may have already sent some of them in the other mails, but,
as I'm not a malayalam expert, I can't figure out easily
which part is actually bad and how to reproduce the problem.

(1) font file name (if possible, with the version number)
(2) problematic character sequence
(3) image of Emacs' rendering of that sequence
(4) image of the correct rendering with the same font

---
Kenichi Handa
[email-masked]